## BYTEPATH

A replayable arcade shooter with a focus on build theorycrafting. Use a massive skill tree, many classes and ships to create your own builds and defeat an ever increasing amount of enemies. 

* **[Steam](https://store.steampowered.com/app/760330/BYTEPATH/)**
* **[Tutorial](https://github.com/a327ex/blog/issues/30)**

<br>

<p align="center">
<img src="https://user-images.githubusercontent.com/409773/41509911-caf3c20a-7231-11e8-96b9-d70596f753f5.gif">
</p>

<p align="center">
<img src="https://i.imgur.com/9E8Stns.gif">
</p>

### Running

**Warning**: running from source or `BYTEPATH.love` and running from a fused release save to different locations.

|OS|not fused|fused|
|---|---|---|
|Windows|`%appdata%\LOVE\BYTEPATH`|`%appdata%\BYTEPATH`|
|Linux|`$XDG_DATA_HOME/love/BYTEPATH`|`$XDG_DATA_HOME/BYTEPATH`|

#### Without Steam
##### Windows

1. download `BYTEPATH-win32.zip` from the latest [release](https://github.com/RunningDroid/BYTEPATH/releases)
2. extract & run!

##### Linux

1. download `BYTEPATH.AppImage` from the latest [release](https://github.com/RunningDroid/BYTEPATH/releases)
2. `chmod +x BYTEPATH.AppImage` & run!

#### With Steam
##### Windows

1. Download `BYTEPATH-win32.zip` from the latest [release](https://github.com/RunningDroid/BYTEPATH/releases)
2. Extract `BYTEPATH-win32.zip` on top of the version installed by Steam
    - It's most likely `C:\Program Files (x86)\Steam\steamapps\common\BYTEPATH`
3. Copy `steam_api.dll` from another game and put it in the folder you just extracted
    - Or you can grab a `steam_api.dll` from the [Steamworks SDK](https://partner.steamgames.com/downloads/list) instead
4. Enjoy your achievements!

##### Linux

1. Download `game_64.AppImage` from the latest [release](https://github.com/RunningDroid/BYTEPATH/releases)
2. Replace the `game_64.AppImage` Steam has with the one you just downloaded
    - It's most likely in `$XDG_DATA_HOME/Steam/steamapps/common/BYTEPATH`
3. Copy `libsteam_api.so` from another game and put it in the same folder as `game_64.AppImage`
    - Or you can grab a `libsteam_api.so` from the [Steamworks SDK](https://partner.steamgames.com/downloads/list) instead
4. Enjoy your achievements!

---

### Tutorial

A full tutorial where the game is built from scratch is available [here](https://github.com/a327ex/blog/issues/30). This tutorial goes over the entire process of building the game step by step. The `tutorial` folder in this repository also contains the necessary files to follow along with the tutorial as well as answers to exercises (look into them only after really trying to answer!).

---

### License

All assets have their specific licenses and they are linked to in the game's credits. All code is under the MIT license.

AIRGLOW music is licensed under CC-BY-3.0
https://airglow-strat.bandcamp.com/album/airglow-memory-bank

Anonymous.ttf is licensed under Open Font License.
https://www.marksimonson.com/fonts/view/anonymous-pro

Arch.ttf is Public Domain.
http://www.pentacom.jp/pentacom/bitfontmaker2/gallery/?id=612

m5x7.ttf is free to use but attribution appreciated.
https://managore.itch.io/m5x7

menu_error.ogg was created by KorGround and is licensed under CC-BY-3.0
https://freesound.org/people/KorGround/sounds/344687/

Sound assets from freesounds.org are probably CC0 or CC-BY-3.0. The site allows CC-BY-NC-3.0 but it seems unlikely the commercial game included any of those. Given that the sounds have probably been converted to ogg and all have been renamed it would be difficult to track down the originals.

fins: https://freesound.org/people/Leszek_Szary/

jeckkech: https://freesound.org/people/jeckkech/

josepharaoh99: https://freesound.org/people/josepharaoh99/

NSStudios: https://freesound.org/people/nsstudios/

TreasureSounds: https://freesound.org/people/TreasureSounds/

TheDweebMan: https://freesound.org/people/TheDweebMan/

LittleRobotSoundFactory: https://freesound.org/people/LittleRobotSoundFactory/

NenadSimic: https://freesound.org/people/NenadSimic/

DrMinky: https://freesound.org/people/DrMinky/

pyzaist: https://freesound.org/people/pyzaist/

CGEffex: https://freesound.org/people/CGEffex/

broumbroum: https://freesound.org/people/broumbroum/

Not sure why this is in credits

GameAudio: https://www.gameaudio101.com/
